# the plugin code was generated by this script
# you should not change the plugin code directly, but this script
# note: this script only creates objects in your workspace,
# *EXCEPT* for the last call, see below.

require(rkwarddev)

local({
# set the output directory to overwrite the actual plugin
output.dir <- tempdir()
overwrite <- TRUE

about.info <- rk.XML.about(
	name="rk.subset",
	author=c(
		person(given="Meik", family="Michalke",
			email="meik.michalke@hhu.de", role=c("aut","cre"))),
	about=list(desc="RKWard GUI to define subsets of data objects",
		version="0.01-1", url="http://rkward.sf.net"),
	dependencies=list(rkward.min="0.5.6")
	)

############
## re-usable objects
############

# for data
var.select <- rk.XML.varselector(label="Select data")
var.data <- rk.XML.varslot(label="Data (data.frame)", source=var.select, classes=c("data.frame"), required=TRUE, id.name="var_data")

selected.vars <- rk.XML.varslot(label="Selected variables", source=var.select, multi=TRUE)
frame.selected.vars <- rk.XML.frame(selected.vars, label="Only use a subset of variables", checkable=TRUE, chk=FALSE)

filter.var <- rk.XML.varslot(label="Filter by", source=var.select)
sset.filter.drop <- rk.XML.dropdown(label="Filter rule", options=list(
		"includes (%in%)"=c(val="%in%"),
		"does not include (!%in%)"=c(val="!%in%"),
		"is not equal (!=)"=c(val="!="),
		"is less (<)"=c(val="<"),
		"is less or equal(<=)"=c(val="<="),
		"is equal (==)"=c(val="==", chk=TRUE),
		"is greater or equal (>=)"=c(val=">="),
		"is greater (>)"=c(val=">")
	), id.name="drp_fltr_all")
sset.filter.drop.factor <- rk.XML.dropdown(label="Filter rule", options=list(
		"includes (%in%)"=c(val="%in%"),
		"does not include (!%in%)"=c(val="!%in%"),
		"is not equal (!=)"=c(val="!="),
		"is equal (==)"=c(val="==", chk=TRUE)
	), id.name="drp_fltr_fct")
sset.filter.drop.logical <- rk.XML.dropdown(label="Filter rule", options=list(
		"is TRUE"=c(val="TRUE", chk=TRUE),
		"is FALSE"=c(val="FALSE")
	), id.name="drp_fltr_lgc")
sset.filter.drop.numeric <- rk.XML.dropdown(label="Filter rule", options=list(
		"is not equal (!=)"=c(val="!="),
		"is less (<)"=c(val="<"),
		"is less or equal(<=)"=c(val="<="),
		"is equal (==)"=c(val="==", chk=TRUE),
		"is greater or equal (>=)"=c(val=">="),
		"is greater (>)"=c(val=">")
	), id.name="drp_fltr_num")
sset.input.filter <- rk.XML.input(label="Value (pasted as-is, use proper quoting!)")
sset.spin.filter <- rk.XML.spinbox(label="Value")

frame.filter.var <- rk.XML.frame(
	filter.var,
	sset.filter.drop,
	sset.filter.drop.factor,
	sset.filter.drop.logical,
	sset.filter.drop.numeric,
	sset.input.filter,
	sset.spin.filter,
	label="Filter rows by variable", checkable=TRUE, chk=FALSE)

# for logic section
lgc.filter.script <- rk.comment(id("
	gui.addChangeCommand(\"", filter.var, ".available\", \"dataChanged()\");
	// this function is called whenever the data was changed
	dataChanged = function(){
			var filterFactor = \"false\";
			var filterLogical = \"false\";
			var filterNumeric = \"false\";
			var filterAll = \"true\";
			var enableVarSpin = \"false\";
			var visibleVarSpin = \"false\";
			var visibleVarInput = \"true\";
			var enableVarInput = \"true\";
			var requireVarInput = \"false\";
			var thisObject = makeRObject(gui.getValue(\"", filter.var, ".available\"));
			 if(thisObject.classes()){
				requireVarInput = \"true\";
				if(thisObject.isDataFactor() || thisObject.isDataCharacter()){
					filterAll = \"false\";
					filterFactor = \"true\";
				} else if(thisObject.isDataLogical()){
					filterAll = \"false\";
					filterLogical = \"true\";
					enableVarInput = \"false\";
					requireVarInput = \"false\";
				} else if(thisObject.isDataNumeric()){
					filterAll = \"false\";
					filterNumeric = \"true\";
					enableVarSpin = \"true\";
					visibleVarSpin = \"true\";
					enableVarInput = \"false\";
					visibleVarInput = \"false\";
					requireVarInput = \"false\";
				} else {}
			} else {}
			gui.setValue(\"", sset.filter.drop.factor, ".visible\", filterFactor);
			gui.setValue(\"", sset.filter.drop.logical, ".visible\", filterLogical);
			gui.setValue(\"", sset.filter.drop.numeric, ".visible\", filterNumeric);
			gui.setValue(\"", sset.filter.drop, ".visible\", filterAll);
			gui.setValue(\"", sset.input.filter, ".enabled\", enableVarInput);
			gui.setValue(\"", sset.input.filter, ".visible\", visibleVarInput);
			gui.setValue(\"", sset.input.filter, ".required\", requireVarInput);
			gui.setValue(\"", sset.spin.filter, ".visible\", visibleVarSpin);
		}", js=FALSE))

save.results.sset <- rk.XML.saveobj("Save results to workspace", initial="sset.result", chk=TRUE)

tab.sset.data <- rk.XML.row(
		var.select,
		rk.XML.col(
			var.data,
			frame.selected.vars,
			frame.filter.var,
			rk.XML.stretch(),
			save.results.sset
		)
	)

sset.full.dialog <- rk.XML.dialog(
	tab.sset.data,
	label="Subset of data")

## logic section
  lgc.sect.sset <- rk.XML.logic(
		lgc.filter.script,
		rk.XML.set(sset.filter.drop.factor, set="visible", to="false"),
		rk.XML.set(sset.filter.drop.logical, set="visible", to="false"),
		rk.XML.set(sset.filter.drop.numeric, set="visible", to="false"),
		rk.XML.connect(governor="current_object", client=var.data, set="available"),
		rk.XML.connect(governor=var.data, client=var.select, get="available", set="root"),
		sset.gov.data <- rk.XML.convert(sources=list(available=var.data), mode=c(notequals="")),
 		rk.XML.connect(governor=sset.gov.data, client=frame.selected.vars, set="enabled"),
 		rk.XML.connect(governor=sset.gov.data, client=frame.filter.var, set="enabled")
  	)

## JavaScript
js.frm.filter <- rk.JS.vars(frame.filter.var, modifiers="checked") # see if the frame is checked
js.frm.subset <- rk.JS.vars(frame.selected.vars, modifiers="checked")

sset.js.calc <- rk.paste.JS(
	js.selected.vars <- rk.JS.vars(selected.vars, modifiers="shortname", join="\\\", \\\""), # get selected vars
	js.filter.var <- rk.JS.vars(filter.var, modifiers="shortname", join="\\\", \\\""),
	js.filter.mode.all <- rk.JS.vars(sset.filter.drop, modifiers="visible"),
	js.filter.mode.fct <- rk.JS.vars(sset.filter.drop.factor, modifiers="visible"),
	js.filter.mode.lgc <- rk.JS.vars(sset.filter.drop.logical, modifiers="visible"),
	js.filter.mode.nmb <- rk.JS.vars(sset.filter.drop.numeric, modifiers="visible"),
	echo("\tsset.result <- subset("),
	ite(var.data, echo("\n\t\t", var.data)),
	ite(id(js.filter.mode.all, " == \"true\" && ", js.frm.filter, " && ", js.filter.var, " != \"\""),
		ite(id(sset.filter.drop, " == \"!%in%\""),
			echo(",\n\t\t!", js.filter.var, " %in% ", sset.input.filter),
			echo(",\n\t\t", js.filter.var, " ", sset.filter.drop, " ", sset.input.filter)
		),
		ite(id(js.filter.mode.fct, " == \"true\" && ", js.frm.filter, " && ", js.filter.var, " != \"\""),
			ite(id(sset.filter.drop.factor, " == \"!%in%\""),
				echo(",\n\t\t!", js.filter.var, " %in% ", sset.input.filter),
				echo(",\n\t\t", js.filter.var, " ", sset.filter.drop.factor, " ", sset.input.filter)
			),
			ite(id(js.filter.mode.lgc, " == \"true\" && ", js.frm.filter),
				ite(id(sset.filter.drop.logical, " == \"TRUE\""),
					echo(",\n\t\t", js.filter.var),
					echo(",\n\t\t!", js.filter.var)
				),
				ite(id(js.filter.mode.nmb, " == \"true\" && ", js.frm.filter),
					echo(",\n\t\t", js.filter.var, " ", sset.filter.drop.numeric, " ", sset.spin.filter)
				)
			)
		)
	),
	ite(id(js.frm.subset, " && ", js.selected.vars, " != \"\""), echo(",\n\t\tselect=c(\"", js.selected.vars, "\")")),
	echo("\n\t)\n\n")
)


#############
## if you run the following function call, files will be written to tempdir!
#############
# this is where it get's serious, that is, here all of the above is put together into one plugin

sset.plugin.dir <<- rk.plugin.skeleton(
	about.info,
	path=output.dir,
	xml=list(
 		dialog=sset.full.dialog,
  		logic=lgc.sect.sset
		),
	js=list(results.header=FALSE,
		calculate=sset.js.calc),
	pluginmap=list(name="Subset of data.frame", hierarchy=list("data")),
	create=c("pmap", "xml", "js", "desc"),
	overwrite=overwrite,
	tests=FALSE,
#	edit=TRUE,
	load=TRUE)#,
#	show=TRUE)
})
